;****************************************************************
;                                                               *
;       INTERFACE to GSX-80 from CBASIC Compiler (CB80)         *
;                                                               *
;       File Name: GSXCB80.ASM  (RMAC Source)                   *
;                                                               *
;       Calling Sequence:                                       *
;               GSX (ptsout, intout, ptsin, intin, contrl)      *
;                    Arrays are passed as VARPTR parameters.    *
;               NOTE the sequence of call parameters.           *
;                                                               *
;       Entry:  Return address on Stack+0                       *
;               Pointer to array contrl on Stack+2              *
;               Pointer to array intin  on Stack+4              *
;               Pointer to array ptsin  on Stack+6              *
;               Pointer to array intout on Stack+8              *
;               Pointer to array ptsout on stack+10             *
;                                                               *
;       Exit:   Return address on Stack                         *
;                                                               *
;       Notes:  Calls BDOS with <DE> pointing at the location   *
;               of parameter block on Stack.                    *
;                                                               *
;       History: Oct. 06, 1983  rhk                             *
;                                                               *
;****************************************************************
        public  GSX

BDOS    equ     5

GSX:    lxi     h,2             ; Skip the return address on Stack
        dad     sp              ; Get pointer to the parameter address
        xchg                    ;   into DE.
        mvi     c,115           ; GSX Function number into C-reg
        call    BDOS            ; Call BDOS

        pop     d               ; Get return address
        lxi     h,10            ; Point pass the 5 parameter address
        dad     sp              ; Clean up Stack
        sphl                    ; Update SP
        xchg                    ; Put return address into HL-reg
        pchl                    ; Return
;
;--------------------------------
;
        END
